<template>
  <div id="teacher_class_manage_enrollment_wrapper" class="bt-container">
    <el-breadcrumb class="page-title" separator=">">
      <el-breadcrumb-item :to="{ path: '/a/teacher/class/manage' }">{{ $t('AFFILIATION_ADMIN.MANAGE_REQ_CREATE_CLASS') }}</el-breadcrumb-item>
    </el-breadcrumb>

    <el-table
      :data="tableData">
      <el-table-column
        label="요청 번호"
        prop="req_id"
        width="100">
      </el-table-column>
      <el-table-column
        label="요청자 메일 주소"
        prop="user.email_id"
        width="250">
      </el-table-column>
      <el-table-column
        label="주제 타입"
        prop="type"
        width="180">
      </el-table-column>
      <el-table-column
        label="설명"
        prop="comment">
      </el-table-column>
      

      <el-table-column
        label="-"
        width="90"
        align="left"
      >
      <template slot-scope="scope">
        <el-button type="primary" @click="acceptCreateClassReq(scope.row.req_id, scope.$index)">{{ $t('AFFILIATION_ADMIN.ACCEPT') }}</el-button>
      </template>
      </el-table-column>

      <el-table-column
        label="-"
        width="90"
        align="left"
      >
        <template slot-scope="scope">
          <el-button type="danger" @click="rejectCreateClassReq(scope.row.req_id, scope.$index)">{{ $t('AFFILIATION_ADMIN.REJECT') }}</el-button>
        </template>
      </el-table-column>
    </el-table>

    <el-pagination
      layout="prev, pager, next"
      @current-change="refreshCreateClassReq"
      :total="total">
    </el-pagination>
  </div>
</template>

<script>
import affiliationService from '../../services/affiliationService';

export default {
  name: 'TeacherClassManageEnrollment',
  data() {
    return {
      tableData: [],
      total: 1,
    };
  },
  methods: {
    async acceptCreateClassReq(arg, index) {
      const vm = this;
      await affiliationService.postAcceptCreateClassReq({
        req_id: arg,
      });
      vm.$notify({
        title: vm.$t('NOTIFY.TITLE'),
        message: vm.$t('NOTIFY.SUCCESS'),
        type: 'success',
      });
      vm.tableData.splice(index, 1);
    },
    async rejectCreateClassReq(arg, index) {
      const vm = this;
      await affiliationService.postRejectCreateClassReq({
        req_id: arg,
      });
      vm.$notify({
        title: vm.$t('NOTIFY.TITLE'),
        message: vm.$t('NOTIFY.SUCCESS'),
        type: 'success',
      });
      vm.tableData.splice(index, 1);
    },
    async refreshCreateClassReq(pageNum) {
      const vm = this;
      const res = await affiliationService.getCreateClassReqList({
        status: 0,
        pageNum,
      });
      vm.tableData.length = 0;
      vm.total = res.data.count;
      res.data.result.forEach((element) => {
        switch (element.type) {
          case 1: {
            element.type = '일반';
            break;
          }
          case 2: {
            element.type = '실시간 스트리밍';
            break;
          }
          case 3: {
            element.type = '도커 사용';
            break;
          }
          case 4: {
            element.type = '시연';
            break;
          }
          default: {
            break;
          }
        }
        vm.tableData.push(element);
      });
    },
  },
  components: {
  },
  async mounted() {
    const vm = this;
    await vm.refreshCreateClassReq();
  },
  computed: {
    classId() {
      const vm = this;
      return Number.parseInt(vm.$route.params.classId, 10);
    },
  }
};
</script>

<style lang="scss" scoped>
#teacher_class_manage_enrollment_wrapper {
  .page-title {
    width: 100%;
    height: 24px;
    font-family: SpoqaHanSans;
    font-size: 25px;
    font-weight: bold;
    font-style: normal;
    font-stretch: normal;
    line-height: 1.2;
    letter-spacing: normal;
    color: #000000;

    margin-top : 40px;
    margin-left : 12px;
    margin-bottom : 40px;
  }
  
  .setting-tabs {
  }
}
</style>